package ar.com.trabajos.broker.client;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;

import ar.com.trabajos.broker.shared.entities.DatosFormAutoDTO;
import ar.com.trabajos.broker.shared.entities.DatosFormPersonaDTO;
import ar.com.trabajos.broker.shared.entities.RequestDTO;
import ar.com.trabajos.broker.shared.entities.ResponseDTO;
import ar.com.trabajos.broker.shared.enums.BrokerEnum;
import ar.com.trabajos.broker.shared.enums.DatosAutoEnum;
import ar.com.trabajos.broker.shared.enums.DatosPersonaEnum;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

/**
 * The client side stub for the RPC service.
 */
@RemoteServiceRelativePath("request")
public interface BrokerService extends RemoteService {

	ResponseDTO requestPresupuesto(RequestDTO input);
	
	DatosFormAutoDTO obtenerDatosAuto();

	DatosFormPersonaDTO obtenerDatosPersona();
		
	void guardarDatosRequest(RequestDTO request);

	LinkedHashMap<Integer, String> obtenerModelosMarca(int codMarca, int codGrupo);

	void enviarMail(HashMap<BrokerEnum, ResponseDTO> respuestas,
			HashMap<DatosAutoEnum, String> datosAuto,
			HashMap<DatosPersonaEnum, String> datosPersona);

	LinkedHashMap<Integer, String> obtenerGruposMarca(int codMarca);

	LinkedHashMap<Double, String> obtenerAnosFabricacion(int codInfoAuto);

	List<Integer> obtenerCodPostalProvincia(int parseInt);


	
}
