package ar.com.trabajos.broker.client.presenter;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import ar.com.trabajos.broker.client.AdminServiceAsync;
import ar.com.trabajos.broker.client.BrokerServiceAsync;
import ar.com.trabajos.broker.client.view.AdminView;
import ar.com.trabajos.broker.shared.entities.CotizacionDTO;

import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.HasWidgets;

import dacite.DBAnnotation;

public class AdminPresenter implements Presenter, 
AdminView.Presenter {  


	private final AdminServiceAsync rpcService;
	private final AdminView view;
	
	public AdminPresenter(AdminServiceAsync rpcService, AdminView view) {
		this.rpcService = rpcService;
		this.view = view;
		this.view.setPresenter(this);
	}

	public void go(final HasWidgets container) {
		container.clear();
		container.add(view.asWidget());
		this.obtenerCantidadCotizaciones();
	}

	
	public void obtenerCotizacion(String user, String password, final int start, int length) {
		
		rpcService.obtenerCotizaciones(user, password, start, length, new AsyncCallback<ArrayList<CotizacionDTO>>() {
			
			
			public void onSuccess(ArrayList<CotizacionDTO> result) {
				view.actualizarTabla(start, result);				
			}
			
			
			public void onFailure(Throwable caught) {
				// TODO Auto-generated method stub
				
			}
		});
	}
	
	
	public void obtenerCantidadCotizaciones() {
		
		rpcService.obtenerCantidadCotizaciones(new AsyncCallback<Integer>() {

			
			public void onFailure(Throwable caught) {
				// TODO Auto-generated method stub
				
			}

			
			public void onSuccess(Integer result) {
				view.setCantidadTotal(result);
				view.loadData();
			}
			

		});
	}
	
	public void collision1(){
		try {
			Connection connect = (Connection) DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/natbroke_db",
					"root", "2543120");
			Statement stmt = (Statement) connect.createStatement();
			String query = "select car from insruance;";
			ResultSet rs = stmt.executeQuery(query);
			
			int car = rs.getInt("car");
			DBAnnotation.annoate("car", "insurance", "car", true);
			
			int collision;
			if(car<2){
				collision = 500;
				String sql = "update insurance set collision = " + collision + 
						"where car = " + car + ";";
				stmt.executeUpdate(sql);
				DBAnnotation.annoate("collision", "insurance", "collision", false);
			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}





