package ar.com.trabajos.broker.server.service;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import nacionseguros_comercial_90.NSWebService;
import nacionseguros_comercial_90.NSWebServiceExecute;
import nacionseguros_comercial_90.NSWebServiceExecuteResponse;
import ar.com.trabajos.broker.server.dao.AppDAO;
import ar.com.trabajos.broker.shared.entities.RequestDTO;
import ar.com.trabajos.broker.shared.entities.ResponseDTO;
import ar.com.trabajos.broker.shared.enums.BrokerEnum;

public class ObtenerCotizacionNacion implements Cotizador  {
	private static Log log = LogFactory.getLog(ObtenerCotizacionElComercio.class);

	public ResponseDTO cotizar(RequestDTO input) {
		AppDAO dao = new AppDAO();
		ResponseDTO response = new ResponseDTO();
		response.setBroker(BrokerEnum.NACION);
		HashMap<String, String> datosParaXML= new HashMap<String, String>();
		//int marcaCod = Integer.parseInt(input.getMarca());
		//int modeloAuto= Integer.parseInt(input.getModeloAuto());
		//Nacion utiliza un codigo de marca + modelo en un dato
		datosParaXML.put("infoAutoCod", input.getCodInfoAuto());

		int uso = dao.obtenerCodigoUso(input.getTipoUso(), BrokerEnum.NACION);
		datosParaXML.put("usoVeh", Integer.toString(uso));

		//Asume fecha de hoy
		SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
		datosParaXML.put("vigDesde", formateador.format(new Date()));

		Calendar cal = Calendar.getInstance();
		String esCeroKm;
		if (Integer.parseInt(input.getModelo())>=cal.get(Calendar.YEAR))
			esCeroKm="S";
		else
			esCeroKm="N";
		datosParaXML.put("esCeroKm", esCeroKm);

		NSWebServiceExecute request = new NSWebServiceExecute();

		request.setEntrada(XMLBuilder.buildXMLNacion(input, datosParaXML));

		request.setLogin("pruebaws");
		request.setPassword("pruebaws052012");
		request.setWstipcod(1);
		try {
			NSWebService ws = new  NSWebService();
			NSWebServiceExecuteResponse wsResponse = ws.getNSWebServiceSoapPort().execute(request);

			//			System.out.println(wsResponse.getSalida());

			response = DigesterDriver.digestNacionResponse(wsResponse.getSalida());	
			response.setBroker(BrokerEnum.NACION);
		}catch (Exception e) {
			log.error("Error en Nacion: " + e.getMessage());
		}

		return response;
	}

}
